MODULE GEWINN
	IMPLICIT NONE
 
	
	CONTAINS
	
	FUNCTION FreiUndZul(Feld,x,y,z)
		INTEGER::x,y,z
		INTEGER,DIMENSION(3,3,3):: Feld
		LOGICAL::FreiUndZul
		
		FreiUndZul=.FALSE.
		
		IF (0< x .AND. x < 4 .AND.0< y .AND. y < 4 .AND.0< z .AND. z < 4) THEN
			FreiUndZul=Feld(x,y,z)==0
		END IF
		
	END FUNCTION
	
	FUNCTION Gewinn_Saeule(Feld)
		INTEGER:: Gewinn_Saeule
		INTEGER,DIMENSION (3,3,3) :: Feld
		
		IF (ANY(SUM(Feld,1)==-3).OR.ANY(SUM(Feld,2)==-3).OR.ANY(SUM(Feld,3)==-3)) THEN
			Gewinn_Saeule=-1
		ELSE IF(ANY(SUM(Feld,1)==3).OR.ANY(SUM(Feld,2)==3).OR.ANY(SUM(Feld,3)==3))  THEN
			Gewinn_Saeule=1
		ELSE
			Gewinn_Saeule=0
		END IF
	END FUNCTION
	
	FUNCTION Gewinn_Raumdiagonale(Feld)
		INTEGER:: Gewinn_Raumdiagonale
		INTEGER,DIMENSION(4)::R
		INTEGER,DIMENSION(3,3,3):: Feld
		R(1)=Feld(1,1,1)+Feld(2,2,2)+Feld(3,3,3)
		R(2)=Feld(1,3,3)+Feld(2,2,2)+Feld(3,1,1)
		R(3)=Feld(1,1,3)+Feld(2,2,2)+Feld(3,3,1)
		R(4)=Feld(1,3,1)+Feld(2,2,2)+Feld(3,1,3)
		IF (ANY(R==-3)) THEN
			Gewinn_Raumdiagonale=-1
		ELSE IF (ANY(R==3)) THEN
			Gewinn_Raumdiagonale=1
		ELSE
			Gewinn_Raumdiagonale=0
		END IF
	END FUNCTION
	
	FUNCTION Gewinn_Flaechendiagonale(Feld)
		INTEGER:: Gewinn_Flaechendiagonale,i,j
		INTEGER,DIMENSION(3,3)::A,B,C
		INTEGER,DIMENSION(3,3,3):: Feld
		
		Gewinn_Flaechendiagonale=0
		DO i=1,3
			A=Feld(i,:,:)
			B=Feld(:,i,:)
			C=Feld(1:3,1:3,i)
			IF (SUM((/(A(j,j),j=1,3)/))==-3 .OR.SUM((/(A(j,4-j),j=1,3)/))==-3 ) THEN
				Gewinn_Flaechendiagonale=-1
				EXIT
			ELSE IF (SUM((/(A(j,j),j=1,3)/))==3 .OR.SUM((/(A(j,4-j),j=1,3)/))==3 ) THEN
				Gewinn_Flaechendiagonale=1
				EXIT
			END IF
			IF (SUM((/(B(j,j),j=1,3)/))==-3 .OR.SUM((/(B(j,4-j),j=1,3)/))==-3 ) THEN
				Gewinn_Flaechendiagonale=-1
				EXIT
			ELSE IF (SUM((/(B(j,j),j=1,3)/))==3 .OR.SUM((/(B(j,4-j),j=1,3)/))==3 ) THEN
				Gewinn_Flaechendiagonale=1
				EXIT
			END IF
			IF (SUM((/(C(j,j),j=1,3)/))==-3 .OR.SUM((/(C(j,4-j),j=1,3)/))==-3 ) THEN
				Gewinn_Flaechendiagonale=-1
				EXIT
			ELSE IF (SUM((/(C(j,j),j=1,3)/))==3 .OR.SUM((/(C(j,4-j),j=1,3)/))==3 ) THEN
				Gewinn_Flaechendiagonale=1
				EXIT
			END IF
		END DO
	END FUNCTION
END MODULE

PROGRAM TicTac
USE GEWINN
IMPLICIT NONE

CHARACTER::antwort
INTEGER:: Aktiv,x,y,z
INTEGER,DIMENSION(3,3,3):: Feld
DO
	Feld=0
	Aktiv=-1
	DO
		DO 
			WRITE(*,*) 'Gib bitte x,y,z Koordinate ein'
			READ(*,*) x,y,z
			IF( FreiUndZul(Feld,x,y,z)) EXIT
			WRITE(*,*) 'Ungültige Eingabe!'
		END DO
		Feld(x,y,z)=Aktiv
		
		IF (Gewinn_Saeule(Feld)==Aktiv .OR. Gewinn_Raumdiagonale(Feld)==Aktiv .OR. &
			& Gewinn_Flaechendiagonale(Feld)==Aktiv) THEN
			WRITE(*,*) Aktiv , 'hat gewonnen'
			EXIT 
		ELSE IF (Gewinn_Saeule(Feld)== -Aktiv .OR. Gewinn_Raumdiagonale(Feld)== -Aktiv .OR. &
			& Gewinn_Flaechendiagonale(Feld) ==-Aktiv) THEN
			WRITE(*,*) 'Fehler! Unmögliche Spielsituation!'
			EXIT
		END IF
		
		IF (ALL(Feld /=0)) THEN
			WRITE(*,*) 'Unentschieden'
			EXIT
		END IF
		AKTIV=-Aktiv

	END DO
	
	WRITE(*,*) 'WOllt ihr nochmal spielen? j für Ja'
	READ(*,*) antwort
	IF (antwort /= 'j' .AND. antwort /='J') EXIT

END DO 

END PROGRAM

	
