! benutze random_init um eine neue Peudozufallsfolge für random_number zu erzeugen
module random
  implicit none
  private
  public random_init
contains
  subroutine random_init()
    integer :: n, unit_nr = 101, stat, clock, i
    integer, dimension(:), allocatable :: seed
    call random_seed(size=n)
    allocate(seed(n))
    open(unit=unit_nr,file="/dev/urandom",status="old",access="stream",action="read", iostat=stat)
    if( stat /= 0 ) then
      write(*,*) "Warning can't open /dev/urandom, use system time instead"
      call system_clock(count=clock)
      seed = clock + 41 * (/ (i, i = 1, n) /)
      call random_seed(put=seed)
    else
      read(unit_nr) seed
      call random_seed(put=seed)
      close(unit_nr)
    end if
    deallocate(seed)
  end subroutine random_init
end module random
